<?php

    /**
     * cache.php
     *
     * Implements a cache using sessions.
     */
     
    class Cache
    {
        /**
         * Returns value of key if it exists, else false.
         */
        public static function get($key)
        {
            // ensure session is started
            if (session_status() == PHP_SESSION_NONE)
            {
                return false;
            }
            
            // check for key
            if (isset($_SESSION["_cache"], $_SESSION["_cache"][$key]))
            {
                return $_SESSION["_cache"][$key];
            }
            else
            {
                return false;
            }
        }
        
        /**
         * Sets value of key.
         */
        public static function set($key, $value)
        {
            // ensure session is started
            if (session_status() == PHP_SESSION_NONE)
            {
                session_start();
            }
            
            // ensure $_SESSION["_cache"] exists
            if (!isset($_SESSION["_cache"]))
            {
                $_SESSION["_cache"] = [];
            }
            
            // set value of key
            $_SESSION["_cache"][$key] = $value;
        }
    }

?>